//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PFilePicker.h"

namespace mozilla {
namespace dom {
namespace PFilePicker {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PFilePickerParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PFilePickerChild>* aChild)
{
    return mozilla::ipc::CreateEndpoints(mozilla::ipc::PrivateIPDLInterface(), aParentDestPid, aChildDestPid, PFilePickerMsgStart, PFilePickerMsgStartChild, aParent, aChild);
}
bool
Transition(
        mozilla::ipc::Trigger trigger,
        State* next)
{
    State from = (*(next));
    switch (from) {
    case __Null:
    case __Error:
        if ((Msg___delete____ID) == ((trigger).mMessage)) {
            (*(next)) = __Dead;
            return true;
        }
        return (__Null) == (from);
    case __Dead:
        mozilla::ipc::LogicError("__delete__()d actor");
        return false;
    case __Dying:
        mozilla::ipc::LogicError("__delete__()d (and unexpectedly dying) actor");
        return false;
    default:
        mozilla::ipc::LogicError("corrupted actor state");
        return false;
    }
}
IPC::Message*
Msg_Open(int32_t routingId)
{
    return new IPC::Message(routingId, Msg_Open__ID, IPC::Message::NOT_NESTED, IPC::Message::NORMAL_PRIORITY, IPC::Message::COMPRESSION_NONE, "PFilePicker::Msg_Open");
}
IPC::Message*
Msg___delete__(int32_t routingId)
{
    return new IPC::Message(routingId, Msg___delete____ID, IPC::Message::NOT_NESTED, IPC::Message::NORMAL_PRIORITY, IPC::Message::COMPRESSION_NONE, "PFilePicker::Msg___delete__");
}
IPC::Message*
Reply___delete__(int32_t routingId)
{
    return new IPC::Message(routingId, Reply___delete____ID, IPC::Message::NOT_NESTED, IPC::Message::NORMAL_PRIORITY, IPC::Message::COMPRESSION_NONE, "PFilePicker::Reply___delete__");
}

} // namespace PFilePicker
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct InputBlobs|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT InputBlobs::InputBlobs()
{
    Init();
}

InputBlobs::~InputBlobs()
{
}

auto InputBlobs::operator==(const InputBlobs& _o) const -> bool
{
    if ((!((blobsParent()) == ((_o).blobsParent())))) {
        return false;
    }
    if ((!((blobsChild()) == ((_o).blobsChild())))) {
        return false;
    }
    return true;
}

auto InputBlobs::Init() -> void
{
}

auto InputBlobs::Assign(
        const nsTArray<PBlobParent*>& _blobsParent,
        const nsTArray<PBlobChild*>& _blobsChild) -> void
{
    blobsParent_ = _blobsParent;
    blobsChild_ = _blobsChild;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct InputDirectory|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT InputDirectory::InputDirectory() :
    directoryPath_()
{
    Init();
}

InputDirectory::~InputDirectory()
{
}

auto InputDirectory::operator==(const InputDirectory& _o) const -> bool
{
    if ((!((directoryPath()) == ((_o).directoryPath())))) {
        return false;
    }
    return true;
}

auto InputDirectory::Init() -> void
{
}

auto InputDirectory::Assign(const nsString& _directoryPath) -> void
{
    directoryPath_ = _directoryPath;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union MaybeInputData|
//
namespace mozilla {
namespace dom {
auto MaybeInputData::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TInputBlobs:
        {
            (ptr_InputBlobs())->~InputBlobs__tdef();
            break;
        }
    case TInputDirectory:
        {
            (ptr_InputDirectory())->~InputDirectory__tdef();
            break;
        }
    case Tvoid_t:
        {
            (ptr_void_t())->~void_t__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT MaybeInputData::MaybeInputData(const InputBlobs& aOther)
{
    new (mozilla::KnownNotNull, ptr_InputBlobs()) InputBlobs(aOther);
    mType = TInputBlobs;
}

MOZ_IMPLICIT MaybeInputData::MaybeInputData(const InputDirectory& aOther)
{
    new (mozilla::KnownNotNull, ptr_InputDirectory()) InputDirectory(aOther);
    mType = TInputDirectory;
}

MOZ_IMPLICIT MaybeInputData::MaybeInputData(const void_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_void_t()) void_t(aOther);
    mType = Tvoid_t;
}

MOZ_IMPLICIT MaybeInputData::MaybeInputData(const MaybeInputData& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TInputBlobs:
        {
            new (mozilla::KnownNotNull, ptr_InputBlobs()) InputBlobs((aOther).get_InputBlobs());
            break;
        }
    case TInputDirectory:
        {
            new (mozilla::KnownNotNull, ptr_InputDirectory()) InputDirectory((aOther).get_InputDirectory());
            break;
        }
    case Tvoid_t:
        {
            new (mozilla::KnownNotNull, ptr_void_t()) void_t((aOther).get_void_t());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MaybeInputData::~MaybeInputData()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto MaybeInputData::operator=(const InputBlobs& aRhs) -> MaybeInputData&
{
    if (MaybeDestroy(TInputBlobs)) {
        new (mozilla::KnownNotNull, ptr_InputBlobs()) InputBlobs;
    }
    (*(ptr_InputBlobs())) = aRhs;
    mType = TInputBlobs;
    return (*(this));
}

auto MaybeInputData::operator=(const InputDirectory& aRhs) -> MaybeInputData&
{
    if (MaybeDestroy(TInputDirectory)) {
        new (mozilla::KnownNotNull, ptr_InputDirectory()) InputDirectory;
    }
    (*(ptr_InputDirectory())) = aRhs;
    mType = TInputDirectory;
    return (*(this));
}

auto MaybeInputData::operator=(const void_t& aRhs) -> MaybeInputData&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (mozilla::KnownNotNull, ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = aRhs;
    mType = Tvoid_t;
    return (*(this));
}

auto MaybeInputData::operator=(const MaybeInputData& aRhs) -> MaybeInputData&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TInputBlobs:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_InputBlobs()) InputBlobs;
            }
            (*(ptr_InputBlobs())) = (aRhs).get_InputBlobs();
            break;
        }
    case TInputDirectory:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_InputDirectory()) InputDirectory;
            }
            (*(ptr_InputDirectory())) = (aRhs).get_InputDirectory();
            break;
        }
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = (aRhs).get_void_t();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto MaybeInputData::operator==(const InputBlobs& aRhs) const -> bool
{
    return (get_InputBlobs()) == (aRhs);
}

auto MaybeInputData::operator==(const InputDirectory& aRhs) const -> bool
{
    return (get_InputDirectory()) == (aRhs);
}

auto MaybeInputData::operator==(const void_t& aRhs) const -> bool
{
    return (get_void_t()) == (aRhs);
}

auto MaybeInputData::operator==(const MaybeInputData& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TInputBlobs:
        {
            return (get_InputBlobs()) == ((aRhs).get_InputBlobs());
        }
    case TInputDirectory:
        {
            return (get_InputDirectory()) == ((aRhs).get_InputDirectory());
        }
    case Tvoid_t:
        {
            return (get_void_t()) == ((aRhs).get_void_t());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto MaybeInputData::get(InputBlobs* aOutValue) const -> void
{
    (*(aOutValue)) = get_InputBlobs();
}

auto MaybeInputData::get(InputDirectory* aOutValue) const -> void
{
    (*(aOutValue)) = get_InputDirectory();
}

auto MaybeInputData::get(void_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_void_t();
}

} // namespace dom
} // namespace mozilla
