//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PTabContext_h
#define PTabContext_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "mozilla/ipc/BackgroundUtils.h"
#include "nsPIDOMWindow.h"
#include "mozilla/dom/PBrowserOrId.h"

namespace mozilla {
namespace dom {
class PBrowserOrId;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PopupIPCTabContext|
//
namespace mozilla {
namespace dom {
class PopupIPCTabContext final
{
private:
    typedef mozilla::dom::PBrowserOrId PBrowserOrId;

public:
    MOZ_IMPLICIT PopupIPCTabContext();

    MOZ_IMPLICIT PopupIPCTabContext(
            const PBrowserOrId& _opener,
            const bool& _isMozBrowserElement)
    {
        Init();
        Assign(_opener, _isMozBrowserElement);
    }

    MOZ_IMPLICIT PopupIPCTabContext(const PopupIPCTabContext& _o)
    {
        Init();
        Assign((_o).opener(), (_o).isMozBrowserElement());
    }

    ~PopupIPCTabContext();

    void
    operator=(const PopupIPCTabContext& _o)
    {
        Assign((_o).opener(), (_o).isMozBrowserElement());
    }

    bool
    operator==(const PopupIPCTabContext& _o) const;

    PBrowserOrId&
    opener()
    {
        return opener_;
    }
    const PBrowserOrId&
    opener() const
    {
        return opener_;
    }

    bool&
    isMozBrowserElement()
    {
        return isMozBrowserElement_;
    }
    const bool&
    isMozBrowserElement() const
    {
        return isMozBrowserElement_;
    }

private:
    void
    Init();

    void
    Assign(
            const PBrowserOrId& _opener,
            const bool& _isMozBrowserElement);

    PBrowserOrId opener_;
    bool isMozBrowserElement_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FrameIPCTabContext|
//
namespace mozilla {
namespace dom {
class FrameIPCTabContext final
{
private:
    typedef mozilla::DocShellOriginAttributes DocShellOriginAttributes;

public:
    MOZ_IMPLICIT FrameIPCTabContext();

    MOZ_IMPLICIT FrameIPCTabContext(
            const DocShellOriginAttributes& _originAttributes,
            const uint32_t& _frameOwnerAppId,
            const bool& _isMozBrowserElement,
            const bool& _isPrerendered,
            const nsString& _presentationURL,
            const UIStateChangeType& _showAccelerators,
            const UIStateChangeType& _showFocusRings)
    {
        Init();
        Assign(_originAttributes, _frameOwnerAppId, _isMozBrowserElement, _isPrerendered, _presentationURL, _showAccelerators, _showFocusRings);
    }

    MOZ_IMPLICIT FrameIPCTabContext(const FrameIPCTabContext& _o)
    {
        Init();
        Assign((_o).originAttributes(), (_o).frameOwnerAppId(), (_o).isMozBrowserElement(), (_o).isPrerendered(), (_o).presentationURL(), (_o).showAccelerators(), (_o).showFocusRings());
    }

    ~FrameIPCTabContext();

    void
    operator=(const FrameIPCTabContext& _o)
    {
        Assign((_o).originAttributes(), (_o).frameOwnerAppId(), (_o).isMozBrowserElement(), (_o).isPrerendered(), (_o).presentationURL(), (_o).showAccelerators(), (_o).showFocusRings());
    }

    bool
    operator==(const FrameIPCTabContext& _o) const;

    DocShellOriginAttributes&
    originAttributes()
    {
        return originAttributes_;
    }
    const DocShellOriginAttributes&
    originAttributes() const
    {
        return originAttributes_;
    }

    uint32_t&
    frameOwnerAppId()
    {
        return frameOwnerAppId_;
    }
    const uint32_t&
    frameOwnerAppId() const
    {
        return frameOwnerAppId_;
    }

    bool&
    isMozBrowserElement()
    {
        return isMozBrowserElement_;
    }
    const bool&
    isMozBrowserElement() const
    {
        return isMozBrowserElement_;
    }

    bool&
    isPrerendered()
    {
        return isPrerendered_;
    }
    const bool&
    isPrerendered() const
    {
        return isPrerendered_;
    }

    nsString&
    presentationURL()
    {
        return presentationURL_;
    }
    const nsString&
    presentationURL() const
    {
        return presentationURL_;
    }

    UIStateChangeType&
    showAccelerators()
    {
        return showAccelerators_;
    }
    const UIStateChangeType&
    showAccelerators() const
    {
        return showAccelerators_;
    }

    UIStateChangeType&
    showFocusRings()
    {
        return showFocusRings_;
    }
    const UIStateChangeType&
    showFocusRings() const
    {
        return showFocusRings_;
    }

private:
    void
    Init();

    void
    Assign(
            const DocShellOriginAttributes& _originAttributes,
            const uint32_t& _frameOwnerAppId,
            const bool& _isMozBrowserElement,
            const bool& _isPrerendered,
            const nsString& _presentationURL,
            const UIStateChangeType& _showAccelerators,
            const UIStateChangeType& _showFocusRings);

    DocShellOriginAttributes originAttributes_;
    uint32_t frameOwnerAppId_;
    bool isMozBrowserElement_;
    bool isPrerendered_;
    nsString presentationURL_;
    UIStateChangeType showAccelerators_;
    UIStateChangeType showFocusRings_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct UnsafeIPCTabContext|
//
namespace mozilla {
namespace dom {
class UnsafeIPCTabContext final
{
private:

public:
    MOZ_IMPLICIT UnsafeIPCTabContext()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT UnsafeIPCTabContext(const UnsafeIPCTabContext& _o)
    {
        Init();
        Assign();
    }

    ~UnsafeIPCTabContext();

    void
    operator=(const UnsafeIPCTabContext& _o)
    {
        Assign();
    }

    bool
    operator==(const UnsafeIPCTabContext& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PopupIPCTabContext;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FrameIPCTabContext;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class UnsafeIPCTabContext;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCTabContext|
//
namespace mozilla {
namespace dom {
class IPCTabContext final
{
public:
    enum Type {
        T__None,
        TPopupIPCTabContext = 1,
        TFrameIPCTabContext,
        TUnsafeIPCTabContext,
        T__Last = TUnsafeIPCTabContext
    };

private:
    typedef mozilla::dom::PopupIPCTabContext PopupIPCTabContext;
    typedef mozilla::dom::FrameIPCTabContext FrameIPCTabContext;
    typedef mozilla::dom::UnsafeIPCTabContext UnsafeIPCTabContext;
    typedef PopupIPCTabContext PopupIPCTabContext__tdef;
    typedef FrameIPCTabContext FrameIPCTabContext__tdef;
    typedef UnsafeIPCTabContext UnsafeIPCTabContext__tdef;

    union Value {
        mozilla::AlignedStorage2<PopupIPCTabContext> VPopupIPCTabContext;
        mozilla::AlignedStorage2<FrameIPCTabContext> VFrameIPCTabContext;
        mozilla::AlignedStorage2<UnsafeIPCTabContext> VUnsafeIPCTabContext;
    };

    PopupIPCTabContext*
    ptr_PopupIPCTabContext()
    {
        return ((mValue).VPopupIPCTabContext).addr();
    }
    const PopupIPCTabContext*
    constptr_PopupIPCTabContext() const
    {
        return ((mValue).VPopupIPCTabContext).addr();
    }
    FrameIPCTabContext*
    ptr_FrameIPCTabContext()
    {
        return ((mValue).VFrameIPCTabContext).addr();
    }
    const FrameIPCTabContext*
    constptr_FrameIPCTabContext() const
    {
        return ((mValue).VFrameIPCTabContext).addr();
    }
    UnsafeIPCTabContext*
    ptr_UnsafeIPCTabContext()
    {
        return ((mValue).VUnsafeIPCTabContext).addr();
    }
    const UnsafeIPCTabContext*
    constptr_UnsafeIPCTabContext() const
    {
        return ((mValue).VUnsafeIPCTabContext).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCTabContext() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCTabContext(const PopupIPCTabContext& aOther);

    MOZ_IMPLICIT IPCTabContext(const FrameIPCTabContext& aOther);

    MOZ_IMPLICIT IPCTabContext(const UnsafeIPCTabContext& aOther);

    MOZ_IMPLICIT IPCTabContext(const IPCTabContext& aOther);

    ~IPCTabContext();

    Type
    type() const
    {
        return mType;
    }

    IPCTabContext&
    operator=(const PopupIPCTabContext& aRhs);

    IPCTabContext&
    operator=(const FrameIPCTabContext& aRhs);

    IPCTabContext&
    operator=(const UnsafeIPCTabContext& aRhs);

    IPCTabContext&
    operator=(const IPCTabContext& aRhs);

    bool
    operator==(const PopupIPCTabContext& aRhs) const;

    bool
    operator==(const FrameIPCTabContext& aRhs) const;

    bool
    operator==(const UnsafeIPCTabContext& aRhs) const;

    bool
    operator==(const IPCTabContext& aRhs) const;

    PopupIPCTabContext&
    get_PopupIPCTabContext()
    {
        AssertSanity(TPopupIPCTabContext);
        return (*(ptr_PopupIPCTabContext()));
    }
    const PopupIPCTabContext&
    get_PopupIPCTabContext() const
    {
        AssertSanity(TPopupIPCTabContext);
        return (*(constptr_PopupIPCTabContext()));
    }
    void
    get(PopupIPCTabContext* aOutValue) const;
    operator PopupIPCTabContext&()
    {
        return get_PopupIPCTabContext();
    }
    operator const PopupIPCTabContext&() const
    {
        return get_PopupIPCTabContext();
    }

    FrameIPCTabContext&
    get_FrameIPCTabContext()
    {
        AssertSanity(TFrameIPCTabContext);
        return (*(ptr_FrameIPCTabContext()));
    }
    const FrameIPCTabContext&
    get_FrameIPCTabContext() const
    {
        AssertSanity(TFrameIPCTabContext);
        return (*(constptr_FrameIPCTabContext()));
    }
    void
    get(FrameIPCTabContext* aOutValue) const;
    operator FrameIPCTabContext&()
    {
        return get_FrameIPCTabContext();
    }
    operator const FrameIPCTabContext&() const
    {
        return get_FrameIPCTabContext();
    }

    UnsafeIPCTabContext&
    get_UnsafeIPCTabContext()
    {
        AssertSanity(TUnsafeIPCTabContext);
        return (*(ptr_UnsafeIPCTabContext()));
    }
    const UnsafeIPCTabContext&
    get_UnsafeIPCTabContext() const
    {
        AssertSanity(TUnsafeIPCTabContext);
        return (*(constptr_UnsafeIPCTabContext()));
    }
    void
    get(UnsafeIPCTabContext* aOutValue) const;
    operator UnsafeIPCTabContext&()
    {
        return get_UnsafeIPCTabContext();
    }
    operator const UnsafeIPCTabContext&() const
    {
        return get_UnsafeIPCTabContext();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

#endif // ifndef PTabContext_h
