//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PQuotaUsageRequest_h
#define PQuotaUsageRequest_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct UsageResponse|
//
namespace mozilla {
namespace dom {
namespace quota {
class UsageResponse final
{
private:

public:
    MOZ_IMPLICIT UsageResponse();

    MOZ_IMPLICIT UsageResponse(
            const uint64_t& _usage,
            const uint64_t& _fileUsage,
            const uint64_t& _limit)
    {
        Init();
        Assign(_usage, _fileUsage, _limit);
    }

    MOZ_IMPLICIT UsageResponse(const UsageResponse& _o)
    {
        Init();
        Assign((_o).usage(), (_o).fileUsage(), (_o).limit());
    }

    ~UsageResponse();

    void
    operator=(const UsageResponse& _o)
    {
        Assign((_o).usage(), (_o).fileUsage(), (_o).limit());
    }

    bool
    operator==(const UsageResponse& _o) const;

    uint64_t&
    usage()
    {
        return usage_;
    }
    const uint64_t&
    usage() const
    {
        return usage_;
    }

    uint64_t&
    fileUsage()
    {
        return fileUsage_;
    }
    const uint64_t&
    fileUsage() const
    {
        return fileUsage_;
    }

    uint64_t&
    limit()
    {
        return limit_;
    }
    const uint64_t&
    limit() const
    {
        return limit_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint64_t& _usage,
            const uint64_t& _fileUsage,
            const uint64_t& _limit);

    uint64_t usage_;
    uint64_t fileUsage_;
    uint64_t limit_;
};
} // namespace quota
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace quota {
class UsageResponse;
} // namespace quota
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union UsageRequestResponse|
//
namespace mozilla {
namespace dom {
namespace quota {
class UsageRequestResponse final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TUsageResponse,
        T__Last = TUsageResponse
    };

private:
    typedef mozilla::dom::quota::UsageResponse UsageResponse;
    typedef nsresult nsresult__tdef;
    typedef UsageResponse UsageResponse__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<UsageResponse> VUsageResponse;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    UsageResponse*
    ptr_UsageResponse()
    {
        return ((mValue).VUsageResponse).addr();
    }
    const UsageResponse*
    constptr_UsageResponse() const
    {
        return ((mValue).VUsageResponse).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT UsageRequestResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT UsageRequestResponse(const nsresult& aOther);

    MOZ_IMPLICIT UsageRequestResponse(const UsageResponse& aOther);

    MOZ_IMPLICIT UsageRequestResponse(const UsageRequestResponse& aOther);

    ~UsageRequestResponse();

    Type
    type() const
    {
        return mType;
    }

    UsageRequestResponse&
    operator=(const nsresult& aRhs);

    UsageRequestResponse&
    operator=(const UsageResponse& aRhs);

    UsageRequestResponse&
    operator=(const UsageRequestResponse& aRhs);

    bool
    operator==(const nsresult& aRhs) const;

    bool
    operator==(const UsageResponse& aRhs) const;

    bool
    operator==(const UsageRequestResponse& aRhs) const;

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    void
    get(nsresult* aOutValue) const;
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    UsageResponse&
    get_UsageResponse()
    {
        AssertSanity(TUsageResponse);
        return (*(ptr_UsageResponse()));
    }
    const UsageResponse&
    get_UsageResponse() const
    {
        AssertSanity(TUsageResponse);
        return (*(constptr_UsageResponse()));
    }
    void
    get(UsageResponse* aOutValue) const;
    operator UsageResponse&()
    {
        return get_UsageResponse();
    }
    operator const UsageResponse&() const
    {
        return get_UsageResponse();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace quota
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace quota {
class PQuotaUsageRequestParent;
} // namespace quota
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace quota {
class PQuotaUsageRequestChild;
} // namespace quota
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PQuotaUsageRequestChild and PQuotaUsageRequestParent
//
namespace mozilla {
namespace dom {
namespace quota {
namespace PQuotaUsageRequest {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::quota::PQuotaUsageRequestParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::quota::PQuotaUsageRequestChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PQuotaUsageRequestStart = PQuotaUsageRequestMsgStart << 16,
    Msg_Cancel__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PQuotaUsageRequestEnd
};

bool
Transition(
        mozilla::ipc::Trigger trigger,
        State* next);

IPC::Message*
Msg_Cancel(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);



} // namespace PQuotaUsageRequest
} // namespace quota
} // namespace dom
} // namespace mozilla

#endif // ifndef PQuotaUsageRequest_h
